	.module Demo_W5500.c
	.area text(rom, con, rel)
	.dbfile D:\PRODUC~2\New_EVB\W5500\W5500_Mega64\UDP\Demo_W5500.c
	.dbfunc e IO_Config _IO_Config fV
	.even
_IO_Config::
	.dbline -1
	.dbline 18
; /*****************************************************************************************
; Company: ɶȻ޹˾ (Chengdu Hasion Electronics Co., Ltd.)
; Tel: +86-28-86127089
; Fax: +86-28-86127039
; Website: http://www.hschip.com
; 
; Date: 2014-02-26
; *****************************************************************************************/
; 
; #include<iom64v.h>
; #include<macros.h>
; 
; #include"device.h"
; #include"W5500.h"
; 
; /* ATMEGA64 IO ports Configuration*/
; void IO_Config(void)
; {
	.dbline 19
; 	DDRA=0xff;		/* PORTA is output */
	ldi R24,255
	out 0x1a,R24
	.dbline 20
; 	PORTA=0xff;
	out 0x1b,R24
	.dbline 22
; 
; 	DDRB=0x37;		/* Config PORTB3/PORTB6/PORTB7 are input, Others are input */
	ldi R24,55
	out 0x17,R24
	.dbline 23
; 	PORTB=0xff;
	ldi R24,255
	out 0x18,R24
	.dbline 25
; 
; 	DDRC=0xff;		/* PORTC is output */
	out 0x14,R24
	.dbline 26
; 	PORTC=0xff;
	out 0x15,R24
	.dbline 28
; 
; 	DDRD=0xff;		/* PORTD is output */
	out 0x11,R24
	.dbline 29
; 	PORTD=0xff;
	out 0x12,R24
	.dbline 31
; 
; 	DDRE=0x76;		/* Config PORTE0/PORTE3/PORTE7 are input, others are output */
	ldi R24,118
	out 0x2,R24
	.dbline 32
; 	PORTE=0xff;
	ldi R24,255
	out 0x3,R24
	.dbline 33
; 	RESET_W5200
	cbi 0x3,2
	.dbline 35
; 
; 	DDRF=0xff;
	sts 97,R24
	.dbline 36
; 	PORTF=0xff;
	sts 98,R24
	.dbline 38
; 
; 	DDRG=0xff;
	sts 100,R24
	.dbline 39
; 	PORTG=0xff;
	sts 101,R24
	.dbline 46
; 
; //	EICRA=0x00;
; //	EICRB=0x80;		/* External INT7 falling edge interrupt */
; //	EIMSK=0x80;		/* Enable INT7 */
; 
; 	/* SPI Pins configuration */
; 	SPCR=0x50;		/* SPI interrupt disable, SPI enable, SPI Master*/
	ldi R24,80
	out 0xd,R24
	.dbline 47
; 	SPSR=0x01;		/* fosc/2 */
	ldi R24,1
	out 0xe,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Timer_Config _Timer_Config fV
	.even
_Timer_Config::
	.dbline -1
	.dbline 52
; }
; 
; /* Timer Configuration */
; void Timer_Config(void)
; {
	.dbline 53
; 	TIMSK=0x01;		/* Enable Timer0 overflow interrupt */
	ldi R24,1
	out 0x37,R24
	.dbline 54
; 	TCCR0=0x05;		/* Timer0 clock is fosc/128 */
	ldi R24,5
	out 0x33,R24
	.dbline 55
; 	TCNT0=170;		/* 1ms overflow */
	ldi R24,170
	out 0x32,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Delay _Delay fV
;              j -> R10,R11
;              i -> R12,R13
;              d -> R16,R17
	.even
_Delay::
	xcall push_gset4
	.dbline -1
	.dbline 74
; }
; 
; //-----------------------------------------------------------------------------
; //UART Initialization
; //-----------------------------------------------------------------------------
; /*void UART_Config(void)
; {
; 	UCSR0A=0x00;
; 	UCSR0B=0xd8;		//Enable TX and RX, enable Tx and Rx inerrupt
; 	UCSR0C=0x86;		//1 start bit, 1 stop bit, 8 data bits, no parity
; 
; 	UBRR0H=0;
; 	UBRR0L=fosc/16/BAUD_Rate-1;
; }
; */
; 
; /* Delay d*1ms */
; void Delay(unsigned int d)
; {
	.dbline 77
; 	unsigned int i,j;
; 
; 	i=timer0;
	lds R12,_timer0
	lds R13,_timer0+1
L4:
	.dbline 79
; 	do
; 	{
	.dbline 80
; 		if(i<timer0)
	lds R2,_timer0
	lds R3,_timer0+1
	cp R12,R2
	cpc R13,R3
	brsh L7
	.dbline 81
; 			j=timer0-i;
	movw R10,R2
	sub R10,R12
	sbc R11,R13
	xjmp L8
L7:
	.dbline 83
; 		else
; 			j=65536-i+timer0;
	movw R2,R12
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	sub R20,R2
	sbc R21,R3
	sbc R22,R4
	sbc R23,R5
	lds R2,_timer0
	lds R3,_timer0+1
	clr R4
	clr R5
	add R20,R2
	adc R21,R3
	adc R22,R4
	adc R23,R5
	movw R10,R20
L8:
	.dbline 84
L5:
	.dbline 84
; 	}while(j<d);
	cp R10,R16
	cpc R11,R17
	brlo L4
	.dbline -2
L3:
	xcall pop_gset4
	.dbline 0 ; func end
	ret
	.dbsym r j 10 i
	.dbsym r i 12 i
	.dbsym r d 16 i
	.dbend
	.dbfunc e W5500_Config _W5500_Config fV
;            dat -> y+2
	.even
_W5500_Config::
	sbiw R28,8
	.dbline -1
	.dbline 89
; }
; 
; /* Config W5500 */
; void W5500_Config(void)
; {
	.dbline 92
; 	unsigned char dat[6];
; 	
; 	Write_1_Byte(MR,RST);
	ldi R18,128
	clr R16
	clr R17
	xcall _Write_1_Byte
	.dbline 93
; 	Delay(10);
	ldi R16,10
	ldi R17,0
	xcall _Delay
	.dbline 96
; 
; 	/* Set Gateway IP as 192.168.0.1 */
; 	dat[0]=192;
	ldi R24,192
	std y+2,R24
	.dbline 97
; 	dat[1]=168;
	ldi R24,168
	std y+3,R24
	.dbline 98
; 	dat[2]=0;
	clr R2
	std y+4,R2
	.dbline 99
; 	dat[3]=1;
	ldi R24,1
	std y+5,R24
	.dbline 100
; 	Write_Bytes(GAR, dat, 4);
	ldi R24,4
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldi R16,1
	ldi R17,0
	xcall _Write_Bytes
	.dbline 103
; 
; 	/* Set Subnet Mask as 255.255.255.0 */
; 	dat[0]=255;
	ldi R24,255
	std y+2,R24
	.dbline 104
; 	dat[1]=255;
	std y+3,R24
	.dbline 105
; 	dat[2]=255;
	std y+4,R24
	.dbline 106
; 	dat[3]=0;
	clr R2
	std y+5,R2
	.dbline 107
; 	Write_Bytes(SUBR, dat, 4);
	ldi R24,4
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldi R16,5
	ldi R17,0
	xcall _Write_Bytes
	.dbline 110
; 
; 	/* Set MAC Address as: 0x48,0x53,0x00,0x57,0x55,0x00 */
; 	dat[0]=0x48;
	ldi R24,72
	std y+2,R24
	.dbline 111
; 	dat[1]=0x53;
	ldi R24,83
	std y+3,R24
	.dbline 112
; 	dat[2]=0x00;
	clr R2
	std y+4,R2
	.dbline 113
; 	dat[3]=0x57;
	ldi R24,87
	std y+5,R24
	.dbline 114
; 	dat[4]=0x55;
	ldi R24,85
	std y+6,R24
	.dbline 115
; 	dat[5]=0x00;
	std y+7,R2
	.dbline 116
; 	Write_Bytes(SHAR, dat, 6);
	ldi R24,6
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldi R16,9
	ldi R17,0
	xcall _Write_Bytes
	.dbline 119
; 
; 	/* Set W5500 IP as 192.168.0.20 */
; 	dat[0]=192;
	ldi R24,192
	std y+2,R24
	.dbline 120
; 	dat[1]=168;
	ldi R24,168
	std y+3,R24
	.dbline 121
; 	dat[2]=0;
	clr R2
	std y+4,R2
	.dbline 122
; 	dat[3]=20;
	ldi R24,20
	std y+5,R24
	.dbline 123
; 	Write_Bytes(SIPR, dat, 4);
	ldi R24,4
	ldi R25,0
	std y+1,R25
	std y+0,R24
	movw R18,R28
	subi R18,254  ; offset = 2
	sbci R19,255
	ldi R16,15
	ldi R17,0
	xcall _Write_Bytes
	.dbline -2
L9:
	adiw R28,8
	.dbline 0 ; func end
	ret
	.dbsym l dat 2 A[6:6]c
	.dbend
	.dbfunc e Detect_Gateway _Detect_Gateway fc
;            dat -> y+2
	.even
_Detect_Gateway::
	sbiw R28,6
	.dbline -1
	.dbline 128
; }
; 
; /* Detect Gateway */
; unsigned char Detect_Gateway(void)
; {
	.dbline 132
; 	unsigned char dat[4];
; 
; 	/* Set a different subnet destination IP */
; 	dat[0]=192+1;
	ldi R24,193
	std y+2,R24
	.dbline 133
; 	dat[1]=168+1;
	ldi R24,169
	std y+3,R24
	.dbline 134
; 	dat[2]=0+1;
	ldi R24,1
	std y+4,R24
	.dbline 135
; 	dat[3]=20+1;
	ldi R24,21
	std y+5,R24
	.dbline 136
; 	Write_SOCK_4_Byte(0,Sn_DIPR,dat);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,12
	ldi R19,0
	clr R16
	xcall _Write_SOCK_4_Byte
	.dbline 139
; 
; 	/* Set Socket n in TCP mode */
; 	Write_SOCK_1_Byte(0,Sn_MR,MR_TCP);
	ldi R24,1
	std y+0,R24
	clr R18
	clr R19
	clr R16
	xcall _Write_SOCK_1_Byte
	.dbline 141
; 	/* Open Socket n */
; 	Write_SOCK_1_Byte(0,Sn_CR,OPEN);
	ldi R24,1
	std y+0,R24
	ldi R18,1
	ldi R19,0
	clr R16
	xcall _Write_SOCK_1_Byte
	.dbline 143
; 
; 	Delay(5);	/* Wait for a moment */
	ldi R16,5
	ldi R17,0
	xcall _Delay
	.dbline 144
; 	if(Read_SOCK_1_Byte(0,Sn_SR)!=SOCK_INIT)
	ldi R18,3
	ldi R19,0
	clr R16
	xcall _Read_SOCK_1_Byte
	cpi R16,19
	breq L28
	.dbline 145
; 	{
	.dbline 146
; 		Write_SOCK_1_Byte(0,Sn_CR,CLOSE);		/* Close Socket 0 */
	ldi R24,16
	std y+0,R24
	ldi R18,1
	ldi R19,0
	clr R16
	xcall _Write_SOCK_1_Byte
	.dbline 147
; 		return false;
	clr R16
	xjmp L24
L28:
	.dbline 151
; 	}
; 
; 	/* Make connect */
; 	Write_SOCK_1_Byte(0,Sn_CR,CONNECT);
	ldi R24,4
	std y+0,R24
	ldi R18,1
	ldi R19,0
	clr R16
	xcall _Write_SOCK_1_Byte
L30:
	.dbline 154
; 	
; 	do
; 	{
	.dbline 155
; 		if(Read_SOCK_1_Byte(0,Sn_IR)&IR_TIMEOUT) 	/* No Gateway Detected */
	ldi R18,2
	ldi R19,0
	clr R16
	xcall _Read_SOCK_1_Byte
	sbrs R16,3
	rjmp L33
	.dbline 156
; 		{
	.dbline 157
; 			Write_SOCK_1_Byte(0,Sn_CR,CLOSE);		/* Close Socket 0 */
	ldi R24,16
	std y+0,R24
	ldi R18,1
	ldi R19,0
	clr R16
	xcall _Write_SOCK_1_Byte
	.dbline 158
; 			return false;
	clr R16
	xjmp L24
L33:
	.dbline 160
; 		}
; 		else if(Read_SOCK_1_Byte(0,Sn_DHAR)!=0xff)	/* Detect Gateway */
	ldi R18,6
	ldi R19,0
	clr R16
	xcall _Read_SOCK_1_Byte
	cpi R16,255
	breq L35
	.dbline 161
; 		{
	.dbline 162
; 			Write_SOCK_1_Byte(0,Sn_CR,CLOSE);		/* Close Socket 0 */
	ldi R24,16
	std y+0,R24
	ldi R18,1
	ldi R19,0
	clr R16
	xcall _Write_SOCK_1_Byte
	.dbline 163
; 			break;
	xjmp L32
L35:
	.dbline 165
L31:
	.dbline 165
; 		}
; 	}while(1);		
	xjmp L30
L32:
	.dbline 166
; 	return true;
	ldi R16,255
	.dbline -2
L24:
	adiw R28,6
	.dbline 0 ; func end
	ret
	.dbsym l dat 2 A[4:4]c
	.dbend
	.dbfunc e Socket0_Config _Socket0_Config fV
;            dat -> y+2
	.even
_Socket0_Config::
	sbiw R28,6
	.dbline -1
	.dbline 171
; }
; 
; /* Config Scoket */
; void Socket0_Config(void)
; {
	.dbline 175
; 	unsigned char dat[4];
; 
; 	/* Set Socket 0 Port Number as 5000 */
; 	Write_SOCK_2_Byte(0,Sn_PORT,5000);		
	ldi R24,5000
	ldi R25,19
	std y+1,R25
	std y+0,R24
	ldi R18,4
	ldi R19,0
	clr R16
	xcall _Write_SOCK_2_Byte
	.dbline 178
; 
; 	/* Set Socket0 Destination IP as 192.168.0.40*/
; 	dat[0]=192;
	ldi R24,192
	std y+2,R24
	.dbline 179
; 	dat[1]=168;
	ldi R24,168
	std y+3,R24
	.dbline 180
; 	dat[2]=0;
	clr R2
	std y+4,R2
	.dbline 181
; 	dat[3]=30;
	ldi R24,30
	std y+5,R24
	.dbline 182
; 	Write_SOCK_4_Byte(0,Sn_DIPR,dat);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,12
	ldi R19,0
	clr R16
	xcall _Write_SOCK_4_Byte
	.dbline 185
; 
; 	/* Set Socket0 Destination Port Number as 5000 */
; 	Write_SOCK_2_Byte(0,Sn_DPORTR,5000);		
	ldi R24,5000
	ldi R25,19
	std y+1,R25
	std y+0,R24
	ldi R18,16
	ldi R19,0
	clr R16
	xcall _Write_SOCK_2_Byte
	.dbline 188
; 
; 	/* Set Maximum Segment Size as 1470 */
; 	Write_SOCK_2_Byte(0, Sn_MSSR, 1470);
	ldi R24,1470
	ldi R25,5
	std y+1,R25
	std y+0,R24
	ldi R18,18
	ldi R19,0
	clr R16
	xcall _Write_SOCK_2_Byte
	.dbline 191
; 
; 	/* Set RX Buffer Size as 2K */
; 	Write_SOCK_1_Byte(0,Sn_RXBUF_SIZE, 0x02);
	ldi R24,2
	std y+0,R24
	ldi R18,30
	ldi R19,0
	clr R16
	xcall _Write_SOCK_1_Byte
	.dbline 193
; 	/* Set TX Buffer Size as 2K */
; 	Write_SOCK_1_Byte(0,Sn_TXBUF_SIZE, 0x02);
	ldi R24,2
	std y+0,R24
	ldi R18,31
	ldi R19,0
	clr R16
	xcall _Write_SOCK_1_Byte
	.dbline -2
L37:
	adiw R28,6
	.dbline 0 ; func end
	ret
	.dbsym l dat 2 A[4:4]c
	.dbend
	.dbfunc e Read_IR _Read_IR fc
;              i -> R20
;              s -> R22
	.even
_Read_IR::
	xcall push_gset2
	mov R22,R16
	sbiw R28,1
	.dbline -1
	.dbline 198
; }
; 
; /*Read interrup flag */
; unsigned char Read_IR(SOCKET s)
; {
	.dbline 201
; 	unsigned char i;
; 
; 	i=Read_SOCK_1_Byte(s,Sn_IR);
	ldi R18,2
	ldi R19,0
	mov R16,R22
	xcall _Read_SOCK_1_Byte
	mov R20,R16
	.dbline 203
; 
; 	if(i!=0)
	tst R16
	breq L42
	.dbline 204
; 		Write_SOCK_1_Byte(s,Sn_IR,i);
	std y+0,R20
	ldi R18,2
	ldi R19,0
	mov R16,R22
	xcall _Write_SOCK_1_Byte
L42:
	.dbline 206
; 
; 	return i;
	mov R16,R20
	.dbline -2
L41:
	adiw R28,1
	xcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbsym r s 22 c
	.dbend
	.dbfunc e Loop_Back _Loop_Back fV
;            dat -> y+2
;              i -> R20,R21
	.even
_Loop_Back::
	xcall push_gset1
	sbiw R28,6
	.dbline -1
	.dbline 211
; }
; 
; /* Process Received data */
; void Loop_Back(void)
; {
	.dbline 215
; 	unsigned int i;
; 	unsigned char dat[4];
; 	
; 	i=Read_SOCK_Data_Buffer(0, S_Buffer);      /* Read W5200 Data to Rx_Buffer */
	ldi R18,<_S_Buffer
	ldi R19,>_S_Buffer
	clr R16
	xcall _Read_SOCK_Data_Buffer
	movw R20,R16
	.dbline 216
; 	if(i==0)
	cpi R16,0
	cpc R16,R17
	brne L45
X0:
	.dbline 217
; 		return;
	xjmp L44
L45:
	.dbline 220
; 	
; 	/* Get Destination IP */
; 	dat[0]=S_Buffer[0];
	lds R2,_S_Buffer
	std y+2,R2
	.dbline 221
; 	dat[1]=S_Buffer[1];
	lds R2,_S_Buffer+1
	std y+3,R2
	.dbline 222
; 	dat[2]=S_Buffer[2];
	lds R2,_S_Buffer+2
	std y+4,R2
	.dbline 223
; 	dat[3]=S_Buffer[3];
	lds R2,_S_Buffer+3
	std y+5,R2
	.dbline 224
; 	Write_SOCK_4_Byte(0,Sn_DIPR,dat);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,12
	ldi R19,0
	clr R16
	xcall _Write_SOCK_4_Byte
	.dbline 226
; 	/* Get Destination Port Number */
; 	Write_SOCK_2_Byte(0,Sn_DPORTR,(S_Buffer[4]*0x100+S_Buffer[5]));
	lds R18,_S_Buffer+4
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	movw R2,R16
	lds R4,_S_Buffer+5
	clr R5
	add R2,R4
	adc R3,R5
	std y+1,R3
	std y+0,R2
	ldi R18,16
	ldi R19,0
	clr R16
	xcall _Write_SOCK_2_Byte
	.dbline 228
; 
; 	i=S_Buffer[6]*0x100+S_Buffer[7];
	lds R18,_S_Buffer+6
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	movw R20,R16
	lds R2,_S_Buffer+7
	clr R3
	add R20,R2
	adc R21,R3
	.dbline 229
; 	Write_SOCK_Data_Buffer(0, S_Buffer+8,i);
	std y+1,R21
	std y+0,R20
	ldi R18,<_S_Buffer+8
	ldi R19,>_S_Buffer+8
	clr R16
	xcall _Write_SOCK_Data_Buffer
L58:
	.dbline 231
;    	do
; 	{
	.dbline 232
; 		i=Read_SOCK_1_Byte(0,Sn_IR);
	ldi R18,2
	ldi R19,0
	clr R16
	xcall _Read_SOCK_1_Byte
	mov R20,R16
	clr R21
	.dbline 233
L59:
	.dbline 233
	sbrc R20,3
	rjmp L61
	sbrs R20,4
	rjmp L58
L61:
	.dbline -2
L44:
	adiw R28,6
	xcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym l dat 2 A[4:4]c
	.dbsym r i 20 i
	.dbend
	.dbfunc e main _main fV
;              i -> R20
	.even
_main::
	sbiw R28,1
	.dbline -1
	.dbline 238
; 	}while(((i&IR_TIMEOUT)==0)&&((i&IR_SEND_OK)==0));
; }
; 
; /***************************** Main Function ********************/
; void main(void)
; {
	.dbline 241
; 	unsigned char i;
; 	
; 	IO_Config();
	xcall _IO_Config
	.dbline 242
; 	Timer_Config();
	xcall _Timer_Config
	.dbline 244
; 
; 	SREG|=0x80;			/* Enable interrupt */
	bset 7
	.dbline 245
; 	Delay(50);
	ldi R16,50
	ldi R17,0
	xcall _Delay
	.dbline 246
; 	SET_W5200
	sbi 0x3,2
L63:
	.dbline 250
; 	
; 	/* Detect Ethernet Link */
; 	do
; 	{
	.dbline 251
; 		Delay(100);					/* wait 100ms */
	ldi R16,100
	ldi R17,0
	xcall _Delay
	.dbline 252
; 		i=Read_1_Byte(PHYCFGR);
	ldi R16,46
	ldi R17,0
	xcall _Read_1_Byte
	mov R20,R16
	.dbline 253
L64:
	.dbline 253
; 	}while((i&LINK)==0);
	sbrs R20,0
	rjmp L63
	.dbline 255
; 
; 	W5500_Config();
	xcall _W5500_Config
	.dbline 256
; 	if(Detect_Gateway()==true)
	xcall _Detect_Gateway
	cpi R16,255
	breq X2
	xjmp L69
X2:
	.dbline 257
; 		OUTPUT1_LOW
	cbi 0x18,5
	xjmp L69
L68:
	.dbline 260
; 
; 	while(1)
; 	{
	.dbline 261
; 		if((Read_1_Byte(PHYCFGR)&LINK)==0)	/* Detect Ethernet Link */
	ldi R16,46
	ldi R17,0
	xcall _Read_1_Byte
	sbrc R16,0
	rjmp L71
	.dbline 262
; 		{
	.dbline 263
; 			OUTPUT2_HIGH
	sbi 0x18,4
	.dbline 264
; 			Write_SOCK_1_Byte(0,Sn_CR,CLOSE);
	ldi R24,16
	std y+0,R24
	ldi R18,1
	ldi R19,0
	clr R16
	xcall _Write_SOCK_1_Byte
L73:
	.dbline 265
L74:
	.dbline 265
; 			while((Read_1_Byte(PHYCFGR)&LINK)==0);		/* Wait Ethernet Link */
	ldi R16,46
	ldi R17,0
	xcall _Read_1_Byte
	sbrs R16,0
	rjmp L73
	.dbline 266
; 		}
L71:
	.dbline 268
; 
; 		i=Read_IR(0);	/* Process IR */
	clr R16
	xcall _Read_IR
	mov R20,R16
	.dbline 269
; 		if(i&IR_TIMEOUT)
	sbrs R16,3
	rjmp L76
	.dbline 270
; 		{
	.dbline 271
; 			OUTPUT2_HIGH
	sbi 0x18,4
	.dbline 272
; 			Write_SOCK_1_Byte(0,Sn_CR,CLOSE);
	ldi R24,16
	std y+0,R24
	ldi R18,1
	ldi R19,0
	clr R16
	xcall _Write_SOCK_1_Byte
	.dbline 273
; 		}		
L76:
	.dbline 275
; 
; 		i=Read_SOCK_1_Byte(0,Sn_SR);
	ldi R18,3
	ldi R19,0
	clr R16
	xcall _Read_SOCK_1_Byte
	mov R20,R16
	.dbline 276
; 		if(i==0)
	tst R16
	brne L78
	.dbline 277
; 		{
	.dbline 278
; 			Socket0_Config();	
	xcall _Socket0_Config
	xjmp L81
L80:
	.dbline 280
	ldi R16,1000
	ldi R17,3
	xcall _Delay
L81:
	.dbline 279
; 			while(Socket_UDP(0)==false)
	clr R16
	xcall _Socket_UDP
	tst R16
	breq L80
	.dbline 281
; 				Delay(1000);
; 			OUTPUT2_LOW
	cbi 0x18,4
	.dbline 282
; 		}
	xjmp L79
L78:
	.dbline 283
; 		else if(i==SOCK_UDP)
	cpi R20,34
	brne L83
	.dbline 284
; 			Loop_Back();
	xcall _Loop_Back
L83:
L79:
	.dbline 285
L69:
	.dbline 259
	xjmp L68
X1:
	.dbline 285
; 	};
	.dbline -2
L62:
	adiw R28,1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbend
	.area vector(rom, abs)
	.org 64
	jmp _TIMER0_OVR
	.area text(rom, con, rel)
	.dbfile D:\PRODUC~2\New_EVB\W5500\W5500_Mega64\UDP\Demo_W5500.c
	.dbfunc e TIMER0_OVR _TIMER0_OVR fV
	.even
_TIMER0_OVR::
	st -y,R24
	st -y,R25
	in R24,0x3f
	st -y,R24
	.dbline -1
	.dbline 301
; }
; 
; //#pragma interrupt_handler EXT_INT7:9
; #pragma interrupt_handler TIMER0_OVR:17
; //#pragma interrupt_handler USART0_Rx:19
; //#pragma interrupt_handler USART0_Tx:21
; 
; /* External interrupt process */
; //void EXT_INT7(void)
; //{
; //	W5200_Interrupt=1;
; //}
; 
; /* Timer0 overflow interrupt, 1ms */
; void TIMER0_OVR(void)
; {
	.dbline 302
; 	TCNT0=170;
	ldi R24,170
	out 0x32,R24
	.dbline 303
; 	timer0++;
	lds R24,_timer0
	lds R25,_timer0+1
	adiw R24,1
	sts _timer0+1,R25
	sts _timer0,R24
	.dbline -2
L85:
	ld R24,y+
	out 0x3f,R24
	ld R25,y+
	ld R24,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area bss(ram, con, rel)
	.dbfile D:\PRODUC~2\New_EVB\W5500\W5500_Mega64\UDP\Demo_W5500.c
_timer0::
	.blkb 2
	.dbfile D:\PRODUC~2\New_EVB\W5500\W5500_Mega64\UDP/device.h
	.dbsym e timer0 _timer0 i
_S_Buffer::
	.blkb 1480
	.dbsym e S_Buffer _S_Buffer A[1480:1480]c
